code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	init			; jump to install routine

new10:	cmp	ah,00h			; mode change?
	je	mode
	cmp	ah,0bh
	je	color
	cmp	ah,0fh			; get current mode?
	je	get
exit:	jmp	cs:old10

mode:	cmp	al,4			; setting mode 4 ?
	je	change
	cmp	al,5			; setting mode 5 ?
	je	change

	mov	cs:prev,0
	jmp	exit

change:	mov	cs:prev,al
	push	ax
	mov	ax,0006h		; set mode 6 instead
	pushf
	call	cs:old10

	push	dx
	mov	dx,03d8h		; flip the color burst bit
	mov	al,1ah
	out	dx,al

	pop	dx
	pop	ax
	iret

color:	cmp	bh,0			; set background/border color?
	jne	exit
	cmp	cs:prev,0		; using the override mode 6?
	je	exit
	iret				; skip setting the color

get:	pushf				; get the current mode
	call	cs:old10
	cmp	cs:prev,0		; using the override mode 6?
	je	done
	mov	al,cs:prev		; report intended video mode
done:	iret

prev	db	0			; intended video mode
old10	dd	0			; old INT 10 address

init:	mov	ax,3510h		; get current INT 10 handler
	int	21h
	mov	word ptr old10,bx
	mov	word ptr old10+2,es

	mov	dx,offset new10		; install new INT 10 handler
	mov	ax,2510h
	int	21h

	mov	es,word ptr[envseg]	; free environment seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0017h		; terminate leaving DX paragraphs resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
